use super::*;

pub trait InCtx<'a, Ctx: Context<'a>>: Inlining {
    fn icnext_address<E>(self, err: impl FnOnce(&[u8]) -> E) -> Result<(Address, Self), E>;

    fn icnext_point<'b, A: Mentionable<'a, Ctx>, E>(
        self,
        factory: A::Fctr,
        err: impl FnOnce(&[u8]) -> E,
    ) -> Result<(Point<'a, Ctx, A>, Self), E> {
        let (point, inctx) = self.icnext_address(err)?;
        Ok((
            Point::from_address(point, factory, inctx.iresolver()),
            inctx,
        ))
    }

    fn iresolver(&self) -> Rc<dyn Resolver<'a, Ctx>>;
}
